// ---------------------------------------------------------------------------
//
// iRobD4.PAS/DFM                                        Ulrich Mller 23.1.00
//                                                       Procida 400NT Delphi4
// fischertechnik Industry Robots : Knickarm Roboter
// in Anlehnung an das TurboPascal des Konstruktionskastens Trainingsroboter
// die Robotfunktionen entsprechen weitgehend denen von Robot85.
// die Drehrichtung hat gewechselt, ebenso die Impulsanzahl
//                                  (4er Rdchen, statt 32er Rad)  
// Basis umFishEx.PAS und umFish.DLL v1.2
//
// Aufbau :
// M1 : Roboter  links gegen den Endtaster E1, Impulstaster E2 -> links
// M2 : Oberarm  links gegen den Endtaster E3, Impulstaster E4 -> hinten
// M3 : Unterarm links gegen den Endtaster E5, Impulstaster E6 -> oben
// M4 : Greifer  links gegen den Endtaster E7, Impulstaster E8 -> offen
//
// ---------------------------------------------------------------------------

unit iRobD4;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, IniFiles, iRoboter, umFishEx;

type
  TfrmMain = class(TForm)
    grpMainMenu: TGroupBox;
    lblTeachInModus: TLabel;
    lblAusfuehren: TLabel;
    lblSpeichern: TLabel;
    lblLaden: TLabel;
    lblDrucken: TLabel;
    lblEnde: TLabel;
    grpTeach: TGroupBox;
    Label1: TLabel;
    lblRoboterLinks: TLabel;
    lblRoboterRechts: TLabel;
    lblOberarmVor: TLabel;
    lblZangeZu: TLabel;
    lblZangeAuf: TLabel;
    lblUnterarmHeben: TLabel;
    lblUnterarmSenken: TLabel;
    lblOberarmZuruck: TLabel;
    lblTeachEnde: TLabel;
    lblLetztePositionLoschen: TLabel;
    lblLetztePositionAnfahren: TLabel;
    lblAktuellePositionSpeichern: TLabel;
    lblHomePosition: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    lblAktRoboter: TLabel;
    lblAktOberarm: TLabel;
    lblAktUnterarm: TLabel;
    lblAktGreifer: TLabel;
    lblSpRoboter: TLabel;
    lblSpOberarm: TLabel;
    lblSpUnterarm: TLabel;
    lblSpGreifer: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    lblArbeitsraumUeberwachung: TLabel;
    lblSegmenteProEingabe: TLabel;
    lblGreifzangenFaktor: TLabel;
    lblNachlaufKorrektur: TLabel;
    lblNachlaufZeit: TLabel;
    lblSpeicherbarePositionen: TLabel;
    lblGFaktorMinus: TLabel;
    Label44: TLabel;
    Label45: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    grpAnzeigen: TGroupBox;
    lblTitel: TLabel;
    Label3: TLabel;
    lblPosSp: TLabel;
    lstDrucken: TListBox;
    lblDruckenEnde: TLabel;
    dlgOpen: TOpenDialog;
    dlgSave: TSaveDialog;
    lblGFaktorPlus: TLabel;
    procedure lblEndeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure lblTeachInModusClick(Sender: TObject);
    procedure lblTeachEndeClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lblSteuerClick(Sender: TObject);
    procedure lblDruckenClick(Sender: TObject);
    procedure lblDruckenEndeClick(Sender: TObject);
    procedure lblLadenClick(Sender: TObject);
    procedure lblSpeichernClick(Sender: TObject);
    procedure lblAusfuehrenClick(Sender: TObject);
  private
    procedure AusFuehren;
    procedure Ausgabe;
    procedure Drucken;
    function  Initialisieren:Boolean;
    procedure KopfZeile;
    procedure LastPosition;
    procedure Lernen;
    procedure Loeschen;
    procedure TeachInControl(Taste: Word);
  public
    { Public-Deklarationen }
  end;

const
  max = 100;
var
  frmMain: TfrmMain;
  INI: TIniFile; Pfad: string; DateiName: string; f: TextFile;
  TeachModus: Boolean; RunModus: Boolean;

  z, n:       Integer;
  a:          array[1..3, 0..max] of string[5];   // --- Positionstabelle
  x:          array[1..3,0..max] of Integer;
  zf:         array[0..max] of string[5];         // --- Greiferstellungen
  q1, q2, q3: Integer;

implementation
{$R *.DFM}
const
  cFarbeEin = $0000FF00; cFarbeAus = $00E0E0E0; cFarbeFehler = $00000FF8;

function TfrmMain.Initialisieren:Boolean;
// --- Zentrale Initialisierungsroutine beim Programmstart ---
var i, j: Cardinal;
begin
// --- Pfad einstellen -----------------------------
  Pfad := ExtractFilePath(Application.ExeName);
  SetCurrentDir(ExtractFileDir(Application.ExeName));
// --- INI-File lesen -------------------------------
  INI := TIniFile.Create(Pfad + 'iRobTD4.INI');
  PortName := INI.ReadString('Common', 'PortName', 'XXX');
  INI.Free;
// --- Interface Open ---------------------------------------------
  if PortName = 'XXX' then PortName := InputBox('Trainingsroboter',
     'PortNamen eingeben : COM1-4 oder LPT1-3 (NT : LPT)', 'LPT1');
  if ftiOpenInterface(PortName) = ftiFehler then begin
    MessageDlg('InterfaceProblem', mtInformation, [mbOK], 0);
    Result := false;
    exit;
    end;
  ftiDCB.LPTDelay := 64;
  
// --- Initialisierungen -------------------
  for j := 0 to max do begin
    for i := 1 to 3 do begin
      a[i,j] := '0';
      x[i,j] := 0;
      end;
    zf[j] := '  auf';
    end;
  gzustand := '     ';
  z := 0;                       // --- Anzahl gespeicherte Positionen
  TeachModus := false; RunModus := false;
  Result := true;

// --- Form zurechtrcken --------------------------------------------
  frmMain.Width       := 536;
  grpMainMenu.Left    := (frmMain.Width - grpMainMenu.ClientWidth) div 2;
  grpMainMenu.Top     := (frmMain.Height - grpMainMenu.ClientHeight) div 2;
  grpAnzeigen.Left    := grpTeach.Left;
  grpAnzeigen.Top     := grpTeach.Top;
  grpAnzeigen.Width   := grpTeach.Width;
  grpAnzeigen.Height  := grpTeach.Height;
  lstDrucken.Width    := grpAnzeigen.ClientWidth - 30;
  lstDrucken.Height   := grpAnzeigen.ClientHeight - 64;
  lblDruckenEnde.Left := lstDrucken.Left + lstDrucken.Width - lblDruckenEnde.Width;
  lblDruckenEnde.Top  := lstDrucken.Top + lstDrucken.Height + 12;
end;

procedure TfrmMain.AusFuehren;
// --- Abfahren der aktuellen Robot Positionsliste -----
var
  t, i, j, anzahl, c: Integer; w, Zeile: string;
  ii: array[1..3] of Integer;
begin
  w := InputBox('Trainingsroboter Ausfhren',
                'Anzahl Durchlufe eingeben : ', '1');
  Val(w, anzahl, i);
  for t := 1 to anzahl do begin
    KopfZeile;
    Home;
    for i := 1 to z do begin
      for j := 1 to 3 do Val(a[j,i], x[j,i], c);
      Str(i:4, Zeile);
      Zeile := Zeile + Format('%12s %10s %12s %12s',
                              [a[1,i], a[2,i], a[3,i], zf[i]]);
      lstDrucken.Items.Add(Zeile);
      for j := 1 to 3 do begin
        ii[j] := ist[j];
        if ii[j] < 0 then ii[j] := 0;
        if Abs(x[j,i]-ii[j]) > 0 then ii[j] := x[j,i];      // --- Robot85 : 10
        if x[j,i]-x[j,i-1] < 0 then Inc(ii[j], nachlauf);
        if x[j,i]-X[j,i-1] > 0 then Dec(ii[j], nachlauf);
        end;
      Robot(ii[1], ii[2], ii[3]);
      if Abbruch then exit;
      if zf[i] <> zf[i-1] then
        if zf[i] = '  auf' then Greifer(auf) else Greifer(zu);
      end;
    end;
end;

procedure TfrmMain.Lernen;
// --- Speichern der aktuellen Position in a[] und zf ----
var i: Cardinal;
begin
  if z < max then begin
    Inc(z);
    for i := 1 to 3 do Str(ist[i]:5, a[i,z]);
    zf[z] := gzustand;
    end;
end;

procedure TfrmMain.Loeschen;
// --- Lschen der aktuellen Position ------------
var i: Integer;
begin
 for i := 1 to 3 do a[i,z] := '0';
 zf[z] := '     ';
 if z > 0 then Dec(z);
end;

procedure TfrmMain.KopfZeile;
// --- Lschen, berschrift : lstDrucken ----------
begin
  lstDrucken.Clear;
  lstDrucken.Items.Add(' Nr.:   Roboter:    Oberarm:   Unterarm:     Greifer:');
end;

procedure TfrmMain.Drucken;
// --- Ausgabe der gespeicherten RobotPositionen in lstDrucken ---
var i, j: Cardinal; Zeile: string;
begin
  KopfZeile;
  for i := 1 to z do begin
    Str(i:4, Zeile);
    for j := 1 to 3 do begin
      Zeile := Zeile + Format('%12s', [a[j,i]]);
      end;
    Zeile := Zeile + '       ' + zf[i];
    lstDrucken.Items.Add(Zeile);
    end;
end;

procedure TfrmMain.TeachInControl(Taste: Word);
// ------ Interaktion im TeachIn Modus --------
//        alternative Bedienung ber num. KeyPad und Maus
begin
  if NOT TeachModus then exit;
  q1 := ist[1];
  q2 := ist[2];
  q3 := ist[3];
  Ausgabe;
  case Taste of         // --- Robot85 : Abweichungen
    VK_NUMPAD4:  begin Dec(q1, segmente);            // --- Cursor links, NumPad
                      lblRoboterLinks.Color := cFarbeEin; end;
    VK_NUMPAD6:  begin Inc(q1, segmente);            //     Cursor rechts
                      lblRoboterRechts.Color := cFarbeEin; end;
    VK_NUMPAD2:  begin Dec(q2, segmente);            //     Cursor untem
                      lblOberarmZuruck.Color := cFarbeEin; end;
    VK_NUMPAD8:  begin Inc(q2, segmente);            //     Cursor oben
                      lblOberarmVor.Color := cFarbeEin; end;
    VK_NUMPAD3:  begin Inc(q3, segmente);            //     Bild unten
                      lblUnterarmSenken.Color := cFarbeEin; end;
    VK_NUMPAD9:  begin Dec(q3, segmente);            //     Bild oben
                      lblUnterarmHeben.Color := cFarbeEin; end;
    VK_SUBTRACT: begin lblZangeAuf.Color := cFarbeEin;
                       Greifer(auf); end;            //     Minus, NumPad
    VK_ADD:      begin lblZangeZu.Color := cFarbeEin;
                       Greifer(zu); end;             //     Plusend;
    VK_HOME:     begin lblHomePosition.color := cFarbeEin;
                       Home; end;                    // --- Pos1
    VK_END:      LastPosition;                       //     Ende
    VK_RETURN:   Lernen;                             //     Return
    VK_DELETE:   Loeschen;                           //     Entf
    VK_F5:       segmente := 16;                     // --- F5-Taste
    VK_F6:       segmente := 8;                      // --- F6-Taste
    VK_F7:       segmente := 4;                      // --- F7-Taste
    VK_F8:       segmente := 2;                      // --- F8-Taste
    VK_F3:       if gfaktor < 100 then Inc(gfaktor); //F3-Taste
    VK_F4:       if gfaktor >1 then dec(gfaktor);    //F4-Taste
  end;
  if Taste in [VK_NUMPAD4, VK_NUMPAD6, VK_NUMPAD2,
               VK_NUMPAD8, VK_NUMPAD3, VK_NUMPAD9] then begin
    TeachModus := false;         // --- Verhindern von weiteren Aktionen
    Robot(q1, q2, q3);
    lblRoboterLinks.Color   := cFarbeAus;
    lblRoboterRechts.Color  := cFarbeAus;
    lblOberarmVor.Color     := cFarbeAus;
    lblOberarmZuruck.Color  := cFarbeAus;
    lblUnterarmSenken.Color := cFarbeAus;
    lblUnterarmHeben.Color  := cFarbeAus;
    TeachModus := true;          //     whrend Robot luft
    end;
  lblZangeAuf.Color       := cFarbeAus;
  lblZangeZu.Color        := cFarbeAus;
  lblHomePosition.Color   := cFarbeAus;
  Ausgabe;
end;

procedure TfrmMain.Ausgabe;
// --- Anzeige aktueller Status ---
begin
  lblPosSp.Caption              := IntToStr(z);
  lblAktRoboter.Caption         := IntToStr(ist[1]);
  lblSpRoboter.Caption          := a[1,z];
  lblAktOberarm.Caption         := IntToStr(ist[2]);
  lblSpOberarm.Caption          := a[2,z];
  lblAktUnterarm.Caption        := IntToStr(ist[3]);
  lblSpUnterarm.Caption         := a[3,z];
  lblAktGreifer.Caption         := gzustand;
  lblSpGreifer.Caption          := zf[z];
  lblGreifzangenFaktor.Caption  := IntToStr(gfaktor);
  lblSegmenteProEingabe.Caption := IntToStr(segmente);
end;

procedure TfrmMain.lblEndeClick(Sender: TObject);
// ----------- ProgrammEnde ---------------------
begin
  Self.Close;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  if NOT Initialisieren then Application.Terminate;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ftiCloseInterface;
  INI := TIniFile.Create(Pfad + 'iRobTD4.INI');
  INI.WriteString('Common', 'PortName', PortName);
  INI.Free;
end;

procedure TfrmMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
// --- Im TeachIn Modus : Bedienung des Robots ---------------
begin
  TeachInControl(Key);
end;

procedure TfrmMain.lblTeachInModusClick(Sender: TObject);
// --- Start TeachIn Modus ------------------------------
begin
  grpMainMenu.Visible := false;
  grpTeach.Visible    := true;
  lblHomePosition.Color := cFarbeEin;
  Home;
  lblHomePosition.Color := cFarbeAus;
  Ausgabe;
  if check then lblArbeitsraumUeberwachung.Caption := 'EIN'
  else lblArbeitsraumUeberwachung.Caption := 'AUS';
  lblSpeicherbarePositionen.Caption := IntToStr(max);
  lblNachlaufZeit.Caption := IntToStr(nl_zeit);
  lblNachlaufKorrektur.Caption := IntToStr(nachlauf);
  TeachModus := true;
end;

procedure TfrmMain.lblTeachEndeClick(Sender: TObject);
// --------- Beenden TeachIn Modus -------------------
begin
  grpTeach.Visible    := false;
  grpMainMenu.Visible := true;
  TeachModus := false;
end;

procedure TfrmMain.lblSteuerClick(Sender: TObject);
// --- Im TeachIn Modus : Bedienung mit Maus ber die beschreibenden Labels ---
begin
  with Sender as TLabel do TeachInControl(Tag);
end;

procedure TfrmMain.LastPosition;
// --- Anfahren der vorherigen Position ----
var
  c, i: Integer;
  x: array[1..max] of Integer;
begin
  lblLetztePositionAnfahren.Color := cFarbeEin;
  for i := 1 to 3 do begin
    Val(a[i,z], x[i],c);
    if x[i] > 0 then Dec(x[i], nachlauf);
    end;
  Robot(x[1], x[2], x[3]);
  if zf[z] = '  auf' then Greifer(auf) else Greifer(zu);
  lblLetztePositionAnfahren.Color := cFarbeAus;
end;

procedure TfrmMain.lblDruckenClick(Sender: TObject);
// --- Start PositionsListe ------------------------
begin
  grpMainMenu.Visible    := false;
  grpAnzeigen.Caption    := 'Programm anzeigen';
  grpAnzeigen.Visible    := true;
  Drucken;
end;

procedure TfrmMain.lblDruckenEndeClick(Sender: TObject);
// --- Beenden der Anzeige der Positionsliste ----------
begin
  RunModus := false;
  grpAnzeigen.Visible    := false;
  grpMainMenu.Visible    := true;
end;

procedure TfrmMain.lblLadenClick(Sender: TObject);
// --- Laden eines Robot ScriptFiles --------------
var i: Cardinal;
begin
  if NOT dlgOpen.Execute then exit;
  DateiName := dlgOpen.FileName;
  AssignFile(f, DateiName);
  {$i-} Reset(f) {$i+};
  if IOResult <> 0 then exit;
  Readln(f, z);
  Readln(f, gfaktor);
  for i := 1 to z do begin
    Read(f, a[1,i], a[2,i], a[3,i]);
    Readln(f, zf[i]);
    end;
  CloseFile(f);
end;

procedure TfrmMain.lblSpeichernClick(Sender: TObject);
// --- Sichern der aktuellen Positionsliste in ein Robot SriptFile ----
var i: Cardinal;
begin
  if NOT dlgSave.Execute then exit;
  DateiName := dlgSave.FileName;
  AssignFile(f, DateiName);
  {$i-} Rewrite(f) {$i+};
  if IOResult <> 0 then exit;
  Writeln(f, z);
  Writeln(f, gfaktor);
  for i := 1 to z do begin
    Write(f, a[1,i], a[2,i], a[3,i]);
    Writeln(f, zf[i]);
    end;
  CloseFile(f);
end;

procedure TfrmMain.lblAusfuehrenClick(Sender: TObject);
// --- Ausfhren eines vorher geladenen Programms ---
begin
  grpMainMenu.Visible    := false;
  grpAnzeigen.Caption    := 'Programm ausfhren';
  grpAnzeigen.Visible    := true;
  lstDrucken.Clear;
  lstDrucken.Items.Add('Fhrt Home Position an');
  Home;
  RunModus := true;
  Ausfuehren;
end;

end.
