// ---------------------------------------------------------------------------
//
// frmMain(iSaeule.PAS)                                  Ulrich Mller 26.1.00
//                                                       Procida 400NT Delphi4
// fischertechnik Industry Robots
// DemoProgramm : SulenRoboter
//
// Verwendung von umFish.DLL und FishPumD aus dem gleichen Pckchen
// Funktionsumfang entspricht dem VB5-Programm
// erweitertes umFishEx.PAS (Basis umFish.PAS)
//
// Beim Start des Programms wird eine Beschreibung der Verkabelung angezeigt
// cmdActionClick lst nach einander folgende Aktionen aus :
// 1. Anzeige InterfacePanel mit OpenInterface
//    und der Mglichkeit das Modell zu testen
// 2. ein automatischer Funktionstest
// 3. Demonstration eines Robot-Auftrages
//
// ---------------------------------------------------------------------------

unit iSaeule;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, jpeg;

type
  TfrmMain = class(TForm)
    cmdAction: TButton;
    cmdEnde: TButton;
    lblDialog: TLabel;
    lblTitel: TLabel;
    pnlDaten: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    imgAction: TImage;
    lstAction: TListBox;
    shpMark: TShape;
    procedure cmdActionClick(Sender: TObject);
    procedure cmdEndeClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    function FunktionsTest(): Boolean;
    procedure Demo();
  public
    { Public-Deklarationen }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

uses FishPumD, umFishEx;

const
cFarbeAus = $8000000F; cFarbAusH = $E0E0E0; CFarbeEin = $FF00;
    cFarbeFehler = $FF8; CFarbeEnde = $80C0FF;
cmSaule = 1; cRSauleRechts = ftiRechts; cRSauleLinks = ftiLinks;
    cRSauleELinks = 1; cRSauleImpuls = 2; cRSaulePRechts = 240;
cmArmW = 2; cRArmVor = ftiRechts; cRArmZuruck = ftiLinks;
    cRArmHinten = 3; cRArmWImpuls = 4; cRArmVorn =160;
cmArmS = 3; cRArmAb = ftiRechts; cRArmAuf = ftiLinks;
    cRArmOben = 5; cRArmSImpuls = 6; cRArmUntern = 150;
cmGreifer = 4; cRGreiferAuf = ftiLinks; cRGreiferZu = ftiRechts;
    cRGreiferOffen = 7; cRGreiferImpuls = 8; cRGreiferPZu = 28;

var
  PortName: string;

procedure TfrmMain.Demo;
// --- Demonstration eines Robot-Auftrages ---

const SL = 288; ST = 208; HL = 232; HT = 96; VL = 328; VT = 64;
      GL = 280; GT = 90;

procedure Aktion(Motor, Richtung, ImpulsTaster, Impulse, Ende: LongInt;
                 MarkLeft, MarkTop: LongInt; AktionsText: string);
// --- Einzelaktion --------------------------------------------------
begin
  ftiSetMotor(Motor, Richtung);            // --- Motor ein
  shpMark.Left := MarkLeft;                // --- Position markieren
  shpMark.Top := MarkTop;
  lstAction.Items.Add(AktionsText);        // --- Protokoll
  ftiWaitForChange(ImpulsTaster, Impulse, Ende);  // --- Warten
  ftiSetMotor(Motor, ftiAus);             // --- Motor aus
end;

begin
  lstAction.Clear;                   // --- Initialisierung
  lstAction.Width := 200;
  lstAction.Visible := true;
  shpMark.Visible := true;
  imgAction.Visible := true;
                                    // --- Einzelaktionen
  Aktion(cmSaule, cRSauleRechts, cRSauleImpuls, 100, cRSauleELinks,
         SL, ST, 'Sule rechts um 100');
  Aktion(cmArmS, cRArmAb, cRArmSImpuls, 80, cRArmVorn,
         VL, VT, 'Arm ab um 80');
  Aktion(cmGreifer, cRGreiferZu, cRGreiferImpuls, 24, cRGreiferZu,
         GL, GT, 'Greifer zu um 24');
  Aktion(cmArmS, cRArmAuf, cRArmSImpuls, 80, cRArmOben,
         VL, VT, 'Arm auf um 80 oder oben');
  Aktion(cmSaule, cRSauleRechts, crSauleImpuls, 120, cRSauleELinks,
         SL, ST, 'Sule rechts um 120');
  Aktion(cmArmS, cRArmAb, cRArmSImpuls, 80, cRArmOben,
         VL, VT, 'Arm ab um 80');
  Aktion(cmArmW, cRArmVor, cRArmWImpuls, 80, cRArmHinten,
         HL, HT, 'Arm vor um 80');
  Aktion(cmGreifer, cRGreiferAuf, crGreiferImpuls, 24, cRGreiferZu,
         GL, GT, 'Greifer auf um 24 / offen');
  Aktion(cmArmS, cRArmAuf, cRArmSImpuls, 80, cRArmOben,
         VL, VT, 'Arm auf um 80 oder oben');
  Aktion(cmArmW, cRArmZuruck, cRArmWImpuls, 80, cRArmHinten,
         HL, HT, 'Arm zurck um 80 oder hinten');

  shpMark.Visible := false;
end;

function TfrmMain.FunktionsTest(): Boolean;
// --- Durchfhren eines Funktionstests -----------------------

begin
  Result := false;                     // --- Initialisierung
  lstAction.Clear;
  lstAction.Visible := true;

  ftiSetMotor(cmSaule, cRSauleLinks);
  lstAction.Items.Add('Sule dreht nach links (M1)');
  ftiWaitForInput(cRSauleELinks, true);
  lstAction.Items.Add('Sule : Endtaster (E1) erreicht');

  ftiSetMotor(cmSaule, cRSauleRechts);
  if ftiWaitForChange(cRSauleImpuls, 25, 0) = ftiFehler then begin
    lstAction.Items.Add('Impulstaster (E2) NICHT gefunden');
    exit;
  end;
  lstAction.Items.Add('Impulstaster (E2) gefunden');

  ftiSetMotor(cmSaule, ftiAus);
  lstAction.Items.Add('Arm fhrt zurck (M2)');
  ftiSetMotor(cmArmW, cRArmZuruck);
  ftiWaitForInput(cRArmHinten, true);
  lstAction.Items.Add('Arm : Endtaster (E3) erreicht');

  ftiSetMotor(cmArmW, cRArmVor);
  if ftiWaitForChange(cRArmWImpuls, 25, 0) = ftiFehler then begin
    lstAction.Items.Add('Impulstaster (E4) NICHT gefunden');
    exit;
  end;
  lstAction.Items.Add('Impulstaster (E4) gefunden');

  ftiSetMotor(cmArmW, ftiAus);
  lstAction.Items.Add('Arm fhrt nach oben');
  ftiSetMotor(cmArmS, cRArmAuf);
  ftiWaitForInput(cRArmOben, true);
  lstAction.Items.Add('Arm : Endtaster (E5) erreicht');

  ftiSetMotor(cmArmS, cRArmAb);
  if ftiWaitForChange(cRArmSImpuls, 25, 0) = ftiFehler then begin
    lstAction.Items.Add('Impulstaster (E6) NICHT gefunden');
    exit;
  end;
  lstAction.Items.Add('Impulstaster (E6) gefunden');

  ftiSetMotor(cmArmS, ftiAus);
  lstAction.Items.Add('Greifer ffnet (M4)');
  ftiSetMotor(cmGreifer, cRGreiferAuf);
  ftiWaitForInput(cRGreiferOffen, true);
  lstAction.Items.Add('Greifer : Endtaster (E7) erreicht');
  ftiSetMotor(cmGreifer, cRGreiferZu);
  if ftiWaitForChange(cRGreiferImpuls, 25, 0) = ftiFehler then begin
    lstAction.Items.Add('Impulstaster (E8) NICHT gefunden');
    exit;
  end;
  lstAction.Items.Add('Impulstaster (E8) gefunden');

  ftiSetMotor(cmGreifer, cRGreiferAuf);
  if ftiWaitForChange(cRGreiferImpuls, 25, 0) = ftiFehler then begin
    lstAction.Items.Add('GreiferFehler');
    exit;
    end;
  ftiSetMotor(cmGreifer, ftiAus);
  lstAction.Visible := false;
  Result := true;
end;

procedure TfrmMain.cmdActionClick(Sender: TObject);
var res: LongWord;
begin
  if cmdAction.Caption = 'START' then begin
// --- OpenInterface und Verkabelungstest -------------------------
    if ParamCount = 0 then
      PortName := InputBox('Demo Sulen Robot',
        'Bitte Portnamen eingeben : COM1-9 / LPT1-3 (NT:LPT)', 'COM1')
    else PortName := ParamStr(1);

    res := ftiOpenInterface(PortName);
    if res = ftiFehler then begin
      MessageDlg('Interface Problem mit : ' + PortName, mtWarning, [mbOK], 0);
      exit;
      end;
    lblDialog.Caption := 'Zum Funktionstest InterfacePanel schlieen';
    frmFishPanel.Left := frmMain.Left + 175;
    frmFishPanel.Top  := frmMain.Top  + 25;
    frmFishPanel.ShowPanel(ftiDCB, PortName);      // --- Anzeige Panel
    cmdAction.Caption := 'TEST';
    exit;
    end
  else begin
// --- Funktionstest --------------------------------------
    pnlDaten.Visible := false;
    lblTitel.Caption := 'Sulen Robot : Funktionstest';
    lblDialog.Caption := 'Funktionstest luft';
    cmdAction.Enabled := false;
    ftiNotHalt := false;
    if NOT FunktionsTest then begin
      lblDialog.Caption := 'Problem beim FunktionsTest';
      cmdAction.Enabled := true;
      exit;
      end;
  end;
// --- Demo -------------------------------------------------
  lblTitel.Caption := 'Sulen Robot : Demo';
  lblDialog.Caption := 'Demo luft';
  Demo;
  lblDialog.Caption := 'Demo beendet';
  cmdEnde.Caption := 'ENDE';
end;

procedure TfrmMain.cmdEndeClick(Sender: TObject);
begin
  Self.Close;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ftiNotHalt := true;
  ftiClearMotors;
  ftiCloseInterface;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
// --- Zurechtrcken der Controls ------------
  lstAction.Width := 500;
  imgAction.Left := pnlDaten.Left + pnlDaten.Width - imgAction.Width;
  imgAction.Top := pnlDaten.Top;
end;

end.
